Debian Bug report logs - #256468
xterm: utmp handling is broken for high pts

Package: kernel; Maintainer for kernel is (unknown);

Reported by: Jim Paris <jim@jtan.com>

Date: Sun, 27 Jun 2004 09:48:01 UTC

Severity: normal

Done: Christoph Hellwig <hch@lst.de>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#256468; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Jim Paris <jim@jtan.com>:
New Bug report received and forwarded. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Jim Paris <jim@jtan.com>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: xterm: utmp handling is broken for high pts
Date: Sun, 27 Jun 2004 05:47:01 -0400
Package: xterm
Version: 4.3.0.dfsg.1-5
Severity: normal

Later Linux 2.6 kernels do not recycle pseudo TTYs, so ptys like 
/dev/pts/1234 are not uncommon.

xterm does not seem to handle this well at all.  In particular, it
relies on the 4-digit ut_id field in utmp, which would look like
"p123" in the above example.  If I open up three xterms on ptys which
all have a ut_id of "p123", they overwrite each other in utmp,
so that only one shows up.  

In wtmp, they all show as opening, but on close, they all act as if
they closed the last record, not their own.

I would assume this is due to code like this (in Exit() in main.c):

            utmp.ut_type = DEAD_PROCESS;

            /* position to entry in utmp file */
            /* Test return value: beware of entries left behind: PSz 9 Mar 00 */
            if (!(utret = getutid(&utmp))) {
                (void) setutent();
                utmp.ut_type = USER_PROCESS;
                if (!(utret = getutid(&utmp))) {
                    (void) setutent();
                }
            }

... which uses getutid() to find the proper entry in utmp, without
matching the full and proper ut_line to make sure that it was the
correct entry.

-- System Information:
Debian Release: testing/unstable
  APT prefers testing
  APT policy: (990, 'testing'), (500, 'unstable'), (1, 'experimental')
Architecture: i386 (i686)
Kernel: Linux 2.6.6
Locale: LANG=C, LC_CTYPE=en_US.UTF-8

Versions of packages xterm depends on:
ii  libc6                     2.3.2.ds1-12   GNU C Library: Shared libraries an
ii  libexpat1                 1.95.6-8       XML parsing C library - runtime li
ii  libfontconfig1            2.2.2-2        generic font configuration library
ii  libfreetype6              2.1.7-2        FreeType 2 font engine, shared lib
ii  libice6                   4.3.0.dfsg.1-1 Inter-Client Exchange library
ii  libncurses5               5.4-3          Shared libraries for terminal hand
ii  libsm6                    4.3.0.dfsg.1-1 X Window System Session Management
ii  libxaw7                   4.3.0.dfsg.1-1 X Athena widget set library
ii  libxext6                  4.3.0.dfsg.1-1 X Window System miscellaneous exte
ii  libxft2                   2.1.2-6        FreeType-based font drawing librar
ii  libxmu6                   4.3.0.dfsg.1-1 X Window System miscellaneous util
ii  libxpm4                   4.3.0.dfsg.1-1 X pixmap library
ii  libxrender1               0.8.3-7        X Rendering Extension client libra
ii  libxt6                    4.3.0.dfsg.1-1 X Toolkit Intrinsics
ii  xlibs                     4.3.0.dfsg.1-1 X Window System client libraries m
ii  xlibs-data                4.3.0.dfsg.1-1 X Window System client data

-- no debconf information



Message sent on to Jim Paris <jim@jtan.com>:
Bug#256468. Full text and rfc822 format available.

Message #8 received at 256468-submitter@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@radix.net>
To: Jim Paris <jim@jtan.com>, 256468-submitter@bugs.debian.org
Subject: Re: Bug#256468: xterm: utmp handling is broken for high pts
Date: Sun, 27 Jun 2004 10:47:21 -0400
[Message part 1 (text/plain, inline)]
On Sun, Jun 27, 2004 at 12:00:11PM +0200, Jim Paris wrote:
> Package: xterm
> Version: 4.3.0.dfsg.1-5
> Severity: normal
> 
> Later Linux 2.6 kernels do not recycle pseudo TTYs, so ptys like 
> /dev/pts/1234 are not uncommon.

I suppose it was to move complexity out of the kernel into the applications.

> xterm does not seem to handle this well at all.  In particular, it
> relies on the 4-digit ut_id field in utmp, which would look like
> "p123" in the above example.  If I open up three xterms on ptys which
> all have a ut_id of "p123", they overwrite each other in utmp,
> so that only one shows up.  
> 
> In wtmp, they all show as opening, but on close, they all act as if
> they closed the last record, not their own.
> 
> I would assume this is due to code like this (in Exit() in main.c):

that seems correct (thanks).

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#256468; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Branden Robinson <branden@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #13 received at 256468@bugs.debian.org (full text, mbox):

From: Branden Robinson <branden@debian.org>
To: Thomas Dickey <dickey@radix.net>, 256468@bugs.debian.org
Subject: Re: Bug#256468: xterm: utmp handling is broken for high pts
Date: Thu, 8 Jul 2004 18:16:29 -0500
[Message part 1 (text/plain, inline)]
On Sun, Jun 27, 2004 at 10:47:21AM -0400, Thomas Dickey wrote:
> On Sun, Jun 27, 2004 at 12:00:11PM +0200, Jim Paris wrote:
> > Package: xterm
> > Version: 4.3.0.dfsg.1-5
> > Severity: normal
> > 
> > Later Linux 2.6 kernels do not recycle pseudo TTYs, so ptys like 
> > /dev/pts/1234 are not uncommon.
> 
> I suppose it was to move complexity out of the kernel into the applications.
> 
> > xterm does not seem to handle this well at all.  In particular, it
> > relies on the 4-digit ut_id field in utmp, which would look like
> > "p123" in the above example.  If I open up three xterms on ptys which
> > all have a ut_id of "p123", they overwrite each other in utmp,
> > so that only one shows up.  
> > 
> > In wtmp, they all show as opening, but on close, they all act as if
> > they closed the last record, not their own.
> > 
> > I would assume this is due to code like this (in Exit() in main.c):
> 
> that seems correct (thanks).

Is it your opinion that this is a bug in the Linux kernel, then?

If so, I will reassign it.  If not, I would like your advice on what should
be done about this bug.  :)

-- 
G. Branden Robinson                |
Debian GNU/Linux                   |     Music is the brandy of the damned.
branden@debian.org                 |     -- George Bernard Shaw
http://people.debian.org/~branden/ |
[signature.asc (application/pgp-signature, inline)]

Message sent on to Jim Paris <jim@jtan.com>:
Bug#256468. Full text and rfc822 format available.

Message #16 received at 256468-submitter@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@radix.net>
To: Branden Robinson <branden@debian.org>
Cc: 256468-submitter@bugs.debian.org
Subject: Re: Bug#256468: xterm: utmp handling is broken for high pts
Date: Thu, 8 Jul 2004 19:40:39 -0400
[Message part 1 (text/plain, inline)]
On Thu, Jul 08, 2004 at 06:16:29PM -0500, Branden Robinson wrote:
> Is it your opinion that this is a bug in the Linux kernel, then?

neither - I did read that this behavior is changed in the next version
of the kernel, but it's something that xterm should (in principle) handle.

But if it's really changed as reported, then I may not have to fix anything.
 
> If so, I will reassign it.  If not, I would like your advice on what should
> be done about this bug.  :)

I'd reassign it to kernel, and get them to state whether the change
in behavior is by design or accident.

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net
[Message part 2 (application/pgp-signature, inline)]

Information stored:
Bug#256468; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Jim Paris <jim@jtan.com>:
Extra info received and filed, but not forwarded. Full text and rfc822 format available.

Message #21 received at 256468-quiet@bugs.debian.org (full text, mbox):

From: Jim Paris <jim@jtan.com>
To: Thomas Dickey <dickey@radix.net>, 256468-quiet@bugs.debian.org
Cc: Branden Robinson <branden@debian.org>, 256468-submitter@bugs.debian.org
Subject: Re: Bug#256468: xterm: utmp handling is broken for high pts
Date: Thu, 8 Jul 2004 20:11:40 -0400
> > Is it your opinion that this is a bug in the Linux kernel, then?
> 
> neither - I did read that this behavior is changed in the next version
> of the kernel, but it's something that xterm should (in principle) handle.
> 
> But if it's really changed as reported, then I may not have to fix anything.

If the Linux kernel behavior reverts to reusing PTYs, that just means
that pty numbers greather than 1000 will be unlikely, but they can
still show up on systems where e.g. more than 1000 users are logged
in.  So the bug should probably be fixed anyway.

The problem is really with the fact that ut_id is so short, so this
may be something that e.g. the glibc people could fix too.

-jim



Message sent on to Jim Paris <jim@jtan.com>:
Bug#256468. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#256468; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Branden Robinson <branden@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #29 received at 256468@bugs.debian.org (full text, mbox):

From: Branden Robinson <branden@debian.org>
To: Thomas Dickey <dickey@radix.net>, control@bugs.debian.org
Cc: kernel@packages.debian.org, 256468@bugs.debian.org
Subject: Re: Bug#256468: xterm: utmp handling is broken for high pts
Date: Fri, 9 Jul 2004 16:46:08 -0500
[Message part 1 (text/plain, inline)]
reassign 256468 kernel
thanks

On Thu, Jul 08, 2004 at 07:40:39PM -0400, Thomas Dickey wrote:
> On Thu, Jul 08, 2004 at 06:16:29PM -0500, Branden Robinson wrote:
> > Is it your opinion that this is a bug in the Linux kernel, then?
> 
> neither - I did read that this behavior is changed in the next version
> of the kernel, but it's something that xterm should (in principle) handle.
> 
> But if it's really changed as reported, then I may not have to fix anything.
>  
> > If so, I will reassign it.  If not, I would like your advice on what should
> > be done about this bug.  :)
> 
> I'd reassign it to kernel, and get them to state whether the change
> in behavior is by design or accident.

Your wish is my command.

Kernel folks:

Is it deliberate that pseudo-tty numbers are never "recycled" in recent
kernel versions?  This can lead to very large numbers; please see the logs
of #256468 for details.

-- 
G. Branden Robinson                |     The more ridiculous a belief
Debian GNU/Linux                   |     system, the higher the probability
branden@debian.org                 |     of its success.
http://people.debian.org/~branden/ |     -- Wayne R. Bartz
[signature.asc (application/pgp-signature, inline)]

Bug reassigned from package `xterm' to `kernel'. Request was from Branden Robinson <branden@debian.org> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Herbert Xu <herbert@debian.org>:
Bug#256468; Package kernel. Full text and rfc822 format available.

Acknowledgement sent to Christoph Hellwig <hch@lst.de>:
Extra info received and forwarded to list. Copy sent to Herbert Xu <herbert@debian.org>. Full text and rfc822 format available.

Message #36 received at 256468@bugs.debian.org (full text, mbox):

From: Christoph Hellwig <hch@lst.de>
To: Branden Robinson <branden@debian.org>
Cc: Thomas Dickey <dickey@radix.net>, control@bugs.debian.org, kernel@packages.debian.org, 256468@bugs.debian.org
Subject: Re: Bug#256468: xterm: utmp handling is broken for high pts
Date: Sat, 10 Jul 2004 00:02:25 +0200
> > I'd reassign it to kernel, and get them to state whether the change
> > in behavior is by design or accident.
> 
> Your wish is my command.
> 
> Kernel folks:
> 
> Is it deliberate that pseudo-tty numbers are never "recycled" in recent
> kernel versions?  This can lead to very large numbers; please see the logs
> of #256468 for details.

It was deliberate, but there's been some forth and back on what's the
better variant.




Information forwarded to debian-bugs-dist@lists.debian.org, Herbert Xu <herbert@debian.org>:
Bug#256468; Package kernel. Full text and rfc822 format available.

Acknowledgement sent to Matthew Wilcox <willy@debian.org>:
Extra info received and forwarded to list. Copy sent to Herbert Xu <herbert@debian.org>. Full text and rfc822 format available.

Message #41 received at 256468@bugs.debian.org (full text, mbox):

From: Matthew Wilcox <willy@debian.org>
To: Branden Robinson <branden@debian.org>
Cc: Thomas Dickey <dickey@radix.net>, kernel@packages.debian.org, 256468@bugs.debian.org
Subject: Re: Bug#256468: xterm: utmp handling is broken for high pts
Date: Sat, 10 Jul 2004 04:25:03 +0100
On Fri, Jul 09, 2004 at 04:46:08PM -0500, Branden Robinson wrote:
> Kernel folks:
> 
> Is it deliberate that pseudo-tty numbers are never "recycled" in recent
> kernel versions?  This can lead to very large numbers; please see the logs
> of #256468 for details.

It was a deliberate decision made in order to reduce the risk of something
or other.  The decision's been reverted due to the bugs found in other
programs *ahem*.  I can get more details if you're interested, but I
think it's probably best to see this as a warning to update this code
at some point.

-- 
"Next the statesmen will invent cheap lies, putting the blame upon 
the nation that is attacked, and every man will be glad of those
conscience-soothing falsities, and will diligently study them, and refuse
to examine any refutations of them; and thus he will by and by convince 
himself that the war is just, and will thank God for the better sleep 
he enjoys after this process of grotesque self-deception." -- Mark Twain



Message sent on to Jim Paris <jim@jtan.com>:
Bug#256468. Full text and rfc822 format available.

Message #44 received at 256468-submitter@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@radix.net>
To: Matthew Wilcox <willy@debian.org>
Cc: 256468-submitter@bugs.debian.org
Subject: Re: Bug#256468: xterm: utmp handling is broken for high pts
Date: Sat, 10 Jul 2004 06:10:27 -0400
[Message part 1 (text/plain, inline)]
On Sat, Jul 10, 2004 at 04:25:03AM +0100, Matthew Wilcox wrote:
> On Fri, Jul 09, 2004 at 04:46:08PM -0500, Branden Robinson wrote:
> > Kernel folks:
> > 
> > Is it deliberate that pseudo-tty numbers are never "recycled" in recent
> > kernel versions?  This can lead to very large numbers; please see the logs
> > of #256468 for details.
> 
> It was a deliberate decision made in order to reduce the risk of something
> or other.  The decision's been reverted due to the bugs found in other
> programs *ahem*.  I can get more details if you're interested, but I
> think it's probably best to see this as a warning to update this code
> at some point.

That's pretty much the way I viewed it (thanks).

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Herbert Xu <herbert@debian.org>:
Bug#256468; Package kernel. Full text and rfc822 format available.

Acknowledgement sent to Branden Robinson <branden@debian.org>:
Extra info received and forwarded to list. Copy sent to Herbert Xu <herbert@debian.org>. Full text and rfc822 format available.

Message #49 received at 256468@bugs.debian.org (full text, mbox):

From: Branden Robinson <branden@debian.org>
To: Thomas Dickey <dickey@radix.net>, kernel@packages.debian.org
Cc: 256468@bugs.debian.org
Subject: Re: Bug#256468: xterm: utmp handling is broken for high pts
Date: Sun, 11 Jul 2004 22:14:47 -0500
[Message part 1 (text/plain, inline)]
On Sat, Jul 10, 2004 at 04:25:03AM +0100, Matthew Wilcox wrote:
> On Fri, Jul 09, 2004 at 04:46:08PM -0500, Branden Robinson wrote:
> > Kernel folks:
> > 
> > Is it deliberate that pseudo-tty numbers are never "recycled" in recent
> > kernel versions?  This can lead to very large numbers; please see the logs
> > of #256468 for details.
> 
> It was a deliberate decision made in order to reduce the risk of something
> or other.  The decision's been reverted due to the bugs found in other
> programs *ahem*.  I can get more details if you're interested, but I
> think it's probably best to see this as a warning to update this code
> at some point.

Can I plead for a consensus view that this either is or is not a bug in
xterm?

-- 
G. Branden Robinson                |    If a man ate a pound of pasta and a
Debian GNU/Linux                   |    pound of antipasto, would they
branden@debian.org                 |    cancel out, leaving him still
http://people.debian.org/~branden/ |    hungry?              -- Scott Adams
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Herbert Xu <herbert@debian.org>:
Bug#256468; Package kernel. Full text and rfc822 format available.

Acknowledgement sent to Christoph Hellwig <hch@lst.de>:
Extra info received and forwarded to list. Copy sent to Herbert Xu <herbert@debian.org>. Full text and rfc822 format available.

Message #54 received at 256468@bugs.debian.org (full text, mbox):

From: Christoph Hellwig <hch@lst.de>
To: Branden Robinson <branden@debian.org>
Cc: Thomas Dickey <dickey@radix.net>, kernel@packages.debian.org, 256468@bugs.debian.org
Subject: Re: Bug#256468: xterm: utmp handling is broken for high pts
Date: Mon, 12 Jul 2004 09:28:56 +0200
On Sun, Jul 11, 2004 at 10:14:47PM -0500, Branden Robinson wrote:
> > 
> > It was a deliberate decision made in order to reduce the risk of something
> > or other.  The decision's been reverted due to the bugs found in other
> > programs *ahem*.  I can get more details if you're interested, but I
> > think it's probably best to see this as a warning to update this code
> > at some point.
> 
> Can I plead for a consensus view that this either is or is not a bug in
> xterm?

It definitly is a bug in XTerm. 




Message sent on to Jim Paris <jim@jtan.com>:
Bug#256468. Full text and rfc822 format available.

Message #57 received at 256468-submitter@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@radix.net>
To: 256468-submitter@bugs.debian.org
Subject: Re: Bug#256468: xterm: utmp handling is broken for high pts
Date: Mon, 12 Jul 2004 05:38:19 -0400
[Message part 1 (text/plain, inline)]
On Sun, Jul 11, 2004 at 10:14:47PM -0500, Branden Robinson wrote:
 
> Can I plead for a consensus view that this either is or is not a bug in
> xterm?

I'm viewing it as a bug (not a major one though).  If pty's aren't recycled,
it'll be noticeable.  If they are recycled, not many people would notice.

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net
[Message part 2 (application/pgp-signature, inline)]

Message sent on to Jim Paris <jim@jtan.com>:
Bug#256468. Full text and rfc822 format available.

Message #60 received at 256468-submitter@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@radix.net>
To: 256468-submitter@bugs.debian.org
Subject: Re: Bug#256468: xterm: utmp handling is broken for high pts
Date: Tue, 20 Jul 2004 05:59:22 -0400
[Message part 1 (text/plain, inline)]
On Sun, Jul 11, 2004 at 10:14:47PM -0500, Branden Robinson wrote:
 
> Can I plead for a consensus view that this either is or is not a bug in
> xterm?

I modified the code in patch #193 to address this (adding a comparison
for the .ut_line data).

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net
[Message part 2 (application/pgp-signature, inline)]

Reply sent to Christoph Hellwig <hch@lst.de>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Jim Paris <jim@jtan.com>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #65 received at 256468-done@bugs.debian.org (full text, mbox):

From: Christoph Hellwig <hch@lst.de>
To: 256468-done@bugs.debian.org
Subject: #256468 xterm: utmp handling is broken for high pts
Date: Wed, 25 Aug 2004 19:52:27 +0200
the kernel changed to a first-fit allocation again.  Note that this
only hides the bugs in buggy applications like xterm but isn't a real
fix.



Message sent on to Jim Paris <jim@jtan.com>:
Bug#256468. Full text and rfc822 format available.

Message #68 received at 256468-submitter@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@radix.net>
To: 256468-submitter@bugs.debian.org
Subject: Re: Bug#256468: marked as done (xterm: utmp handling is broken for high pts)
Date: Wed, 25 Aug 2004 20:47:17 -0400
[Message part 1 (text/plain, inline)]
On Wed, Aug 25, 2004 at 08:10:13PM +0200, Debian Bug Tracking System wrote:
> Received: (at 256468-done) by bugs.debian.org; 25 Aug 2004 17:52:29 +0000
> >From hch@lst.de Wed Aug 25 10:52:29 2004
> Return-path: <hch@lst.de>
> Received: from verein.lst.de (mail.lst.de) [213.95.11.210] 
> 	by spohr.debian.org with esmtp (Exim 3.35 1 (Debian))
> 	id 1C01wj-0004Ld-00; Wed, 25 Aug 2004 10:52:29 -0700
> Received: from verein.lst.de (localhost [127.0.0.1])
> 	by mail.lst.de (8.12.3/8.12.3/Debian-6.6) with ESMTP id i7PHqR95014290
> 	(version=TLSv1/SSLv3 cipher=EDH-RSA-DES-CBC3-SHA bits=168 verify=NO)
> 	for <256468-done@bugs.debian.org>; Wed, 25 Aug 2004 19:52:27 +0200
> Received: (from hch@localhost)
> 	by verein.lst.de (8.12.3/8.12.3/Debian-6.6) id i7PHqRNo014288
> 	for 256468-done@bugs.debian.org; Wed, 25 Aug 2004 19:52:27 +0200
> Date: Wed, 25 Aug 2004 19:52:27 +0200
> From: Christoph Hellwig <hch@lst.de>
> To: 256468-done@bugs.debian.org
> Subject: #256468 xterm: utmp handling is broken for high pts
> Message-ID: <20040825175227.GA14269@lst.de>
> Mime-Version: 1.0
> Content-Type: text/plain; charset=us-ascii
> Content-Disposition: inline
> User-Agent: Mutt/1.3.28i
> X-Spam-Score: -4.901 () BAYES_00
> X-Scanned-By: MIMEDefang 2.39
> Delivered-To: 256468-done@bugs.debian.org
> X-Spam-Checker-Version: SpamAssassin 2.60-bugs.debian.org_2004_03_25 
> 	(1.212-2003-09-23-exp) on spohr.debian.org
> X-Spam-Status: No, hits=-3.0 required=4.0 tests=BAYES_00 autolearn=no 
> 	version=2.60-bugs.debian.org_2004_03_25
> X-Spam-Level: 
> 
> the kernel changed to a first-fit allocation again.  Note that this
> only hides the bugs in buggy applications like xterm but isn't a real
> fix.

hmm - if you had followed up on this, you would have noticed that I fixed
xterm over a month ago.

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net
[Message part 2 (application/pgp-signature, inline)]

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 17 07:37:31 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.